#!/usr/local/bin/php
<?php
/*
    /usr/ports/net/socat http://www.dest-unreach.org/socat/

    Example: socat UDP4-LISTEN:5060,bind=X.X.X.X,reuseaddr,fork EXEC:/path/to/sip_trap.php
*/

$stdin = fopen( 'php://stdin', 'r' );
$sdpIP="1.1.1.1";

$path = realpath( dirname(__FILE__) );
if ($logfile = fopen( sprintf("%s/sip_trap.log",$path), 'a+' )){
    wr2log(sprintf("STARTING AT %s\n\n",date("d.m.Y H:i:s")));
}else{
    print "Can`t open logfile";
    exit(1);
}

$sdp = "v=0\r
o=root 2098770741 2098770741 IN IP4 ".$sdpIP."\r
s=Asterisk PBX 1.4.21.2\r
c=IN IP4 ".$sdpIP."\r
t=0 0\r
m=audio 38180 RTP/AVP 8 101\r
a=rtpmap:8 PCMA/8000\r
a=rtpmap:101 telephone-event/8000\r
a=fmtp:101 0-16\r
a=ptime:20\r
a=sendrecv\r\n\r\n";

$answer = array( );
while( !feof( $stdin ) ){
    $tmp = trim( fgets( $stdin ) );
    if( $tmp === "" ){
	if( isset( $data['invite'] ) || isset( $data['bye'] ) || isset( $data['cancel'] ) ){
	    if( isset( $data['invite'] ) ){
		wr2log( sprintf("[%s] Dial %s from %s",date("d.m.Y H:i:s"),$data['number'],getenv( 'SOCAT_PEERADDR' ) ) );
		unset( $data['number'] );
	    }
	    myAnwser( $data );
	    $data = array( );
	}
    }elseif( preg_match( "/^INVITE/", $tmp) ){
	$data = array( "invite" => "SIP/2.0 200 OK" );
	$data['number'] = preg_replace( "/^.+sip:(\d+)@.+$/","\$1",$tmp );
    }elseif( preg_match( "/^BYE/", $tmp) ){
	$data = array( "bye" => "SIP/2.0 200 OK" );
    }elseif( preg_match( "/^CANCEL/", $tmp) ){
	$data = array( "cancel" => "SIP/2.0 487 Request Terminated" );
    }elseif( preg_match( "/^VIA:/i", $tmp) ){
	$data["via"] = $tmp;
    }elseif( preg_match( "/^FROM:/i", $tmp) ){
	$data["from"] = $tmp;
    }elseif( preg_match( "/^TO:/i", $tmp) ){
	$data["to"] = $tmp;
    }elseif( preg_match( "/^DATE:/i", $tmp) ){
	$data["date"] = $tmp;
    }elseif( preg_match( "/^CALL\-ID:/i", $tmp) ){
	$data["id"] = $tmp;
    }elseif( preg_match( "/^CSEQ:/i", $tmp) ){
	$data["seq"] = $tmp;
    }elseif( preg_match( "/^ALLOW:/i", $tmp) ){
	$data["allow"] = $tmp;
    }elseif( preg_match( "/^CONTACT:/i", $tmp) ){
	$data["contact"] = $tmp;
    }elseif( preg_match( "/^c=IN IP4 .+$/i", $tmp) ){
	$data["ip"] = preg_replace( "/^c=IN IP4 ([\d\.]+)$/i", "\$1", $tmp );
    }elseif( preg_match( "/^Content-Length:/i", $tmp) && isset( $data['bye'] ) ){
	$data["ua"] = "Server: FPBX-2.5.1 (1.4.21.2)";
	$data["allow"] = "Allow: INVITE, ACK, CANCEL, OPTIONS, BYE, NOTIFY, INFO";
	$data["sup"] = "Supported: replaces, timer";
	$data["cl"] = "Content-Length: 0"."\r\n\r\n";
    }elseif( preg_match( "/^Content-Length:/i", $tmp) && isset( $data['cancel'] ) ){
	$data["ua"] = "Server: FPBX-2.5.1 (1.4.21.2)";
	$data["cl"] = "Content-Length: 0"."\r\n\r\n";
    }elseif( preg_match( "/^Content-Type:/i", $tmp) ){
	$data["server"] = "Server: FPBX-2.5.1 (1.4.21.2)";
	$data["ct"] = "Content-Type: application/sdp";
	$data["cd"] = "Content-Disposition: session;handling=required";
	$data["cl"] = "Content-Length: ".strlen($sdp)."\r\n\r\n".$sdp;
    }
}
fclose( $logfile );

function myAnwser($data){
    if( isset( $data['invite'] ) ){
	$tmp=array();
	$tmp[]="SIP/2.0 100 trying -- your call is important to us";
	$tmp[]=$data["via"];
	$tmp[]=$data["from"];
	$tmp[]=$data["to"];
	$tmp[]=$data["id"];
	$tmp[]=$data["seq"];
	$tmp[]=$data["server"];
	$tmp[]="Content-Length: 0";

	print implode( "\r\n", $tmp );
	sleep(1);

	$tmp=array();
	$tmp[]="SIP/2.0 183 Session Progress";
	$tmp[]=$data["via"];
	$tmp[]=$data["from"];
	$tmp[]=$data["to"];
	$tmp[]=$data["date"];
	$tmp[]=$data["id"];
	$tmp[]=$data["allow"];
	$tmp[]=$data["contact"];
	$tmp[]=$data["ct"];
	$tmp[]=$data["cd"];
	$tmp[]=$data["cl"];

	print implode( "\r\n", $tmp );
	sleep(1);

	$tmp=array();
	$tmp[]="SIP/2.0 180 Ringing";
	$tmp[]=$data["via"];
	$tmp[]=$data["from"];
	$tmp[]=$data["to"];
	$tmp[]=$data["id"];
	$tmp[]=$data["seq"];
	$tmp[]=$data["server"];
	$tmp[]=$data["allow"];
	$tmp[]=$data["contact"];
	$tmp[]="Content-Length: 0";

	print implode( "\r\n", $tmp );
	sleep(1);
    }

    print implode( "\r\n", $data );
}

function wr2log( $data ){
	global $logfile;
	if ( is_array($data) ){
	    foreach ($data as $v){
		$log = sprintf( "%s\n", $v);
		fputs( $logfile, $log );
	    }
	    fputs( $logfile, "\n" );
	}else{
	    fputs( $logfile, sprintf( "%s\n", $data ) );
	}
}
?>